Springpad API beta

May 2013

Preface

Springpad wouldn't be possible without the rich set of APIs that already exist on the web. And we're serious about providing open APIs to allow users to export their data for backup, to sync with their other favorite services, or to take advantage of their Springpad data in innovative ways provided by other companies. To that end, we're releasing the Springpad Beta API. This is the same API we use with our mobile platforms and it will enable developers to build applications that can both get data from Springpad and send commands to modify existing Springpad data. We look forward to hearing your feedback on the API and can't wait see what you do with it!

Springpad allows users to quickly capture ideas, chores, or things that they want to save for later. At its most basic, this means taking a note or adding a to-do, but Springpad also makes it easy to capture structured data such as books, restaurants, recipes, and products. This means that if a user has saved a book that he wants to remember, he can find it in the system not only by searching for it but also by browsing for it. Springpad's data structures allow the book to be found based on it being a book, by its genre, or even by price or number of pages. This kind of rich data is available for all of the different data types, in addition to details the user can add to it, such as whether they "have read" the book or "want to read" it or how he rates it.

In addition to making it easy to find things that the user has saved, Springpad also tries to add some additional value to the object. For example, Springpad automatically adds links to reviews of books and movies, links to Yelp and Open Table for restaurants, or price information for products. Further, Springpad has an alert system that delivers pertinent news and offers to users based on their data, such as price drops, coupons, and relevant news stories. All of this data is available to users on the web as well as via our mobile apps.

API

Basic Concepts to understand about Springpad's Datamodel

This document covers how to authenticate with Springpad, how to access, create, and modify objects in the system, how to get basic user information, and the data formats used by the system. Our example code for authentication is written in python and we provide a python API to make integration easier. The API is accessible to most languages since we rely on HTTP protocols, JSON, and OAuth. Before getting into the details of the API, we'll begin with a brief overview of the Springpad system and its datamodel to provide context for the rest of the document.

Every user in Springpad is represented by a user object. Users, as well as every other object in Springpad, are uniquely identified by a UUID. In addition to some information about the user, users have blocks. Generally speaking, blocks refer to the objects that users collect in their account such as notes, tasks, restaurants, etc. For a more precise understanding of the blocks, consider an analogy to an object-oriented type system. Springpad has types which are much like classes. Just like a class, Springpad types have properties, each with a name and a type. Also like classes, types can 'subclass' other types and inherit their properties. If Springpad types are like classes, then blocks are like instances. A block is instantiated from a type just as an instance is from a class. Knowing the type of the blocks, allows you to know what properties the block will have (e.g., a book will have a genre, author, price, etc.).

The specific properties of each type are detailed in the Type API section. First, we'll discuss how to connect to Springpad and interact with the system.

API

In this section, we discuss the Springpad API. It is a somewhat RESTful API that enables services to authenticate as a Springpad user and then query for their blocks, create new blocks, or modify existing ones. We begin by discussing authentication before moving into the rest of the API.

API Version

The beta release of the api is version 5.0. It is important to include the header parameter that identifies which version the request is being made with. The header name is X-Spring-Api-Version.

API Release Notes

7-22-2011

  • Added MusicalArtist data types.
  • Reorganized types so that Album and Book are no longer sub-types of Product.

Authentication

Since Springpad deals in information that is personal to the user it is required that all API requests be made via https. Requests being made on http may be processed temporarily, however, this could compromise users data and we intend to limit this type of access in the near future. Avoiding such a compromise of data is of the utmost importance to us.

Any request to Springpad that modifies data or needs access to private information must successfully authenticate. Springpad supports a simple username and password-based authentication scheme which is intended only to be used for experimentation and one-off calls to the service. For all other uses, we support Oauth. Either authentication method requires that you request access for your application and send the token along with the request to identify your application to Springpad. We'll first discuss how to request the token and then each of the authentication methods in turn.

Requesting API Access

In order to access the Springpad API, you will need to request developer access. To register your application for access, visit our registration page. You will see this page:

-

The form contains the following elements:

  1. Application Name The name you enter here is used to identify your application to the user when asking to grant your application access to their data. It also used to show the user which applications they have approved and allow them to disable applications.
  2. Description is a simple description of the application, which is used to identify your application to the user.
  3. Organization is the name of your organization.
  4. Webite is a website that can be used to learn more about your application or company.
  5. Callback URL is the URL to which the user will be redirected to after granting your application access to their data.
  6. Contact email we store this in case we need to get in touch with you
  7. Estimated Daily Requests gives us an idea of how much traffic to expect from your app. A very rough estimate is all that is required.
  8. Summary is a basic description of how you plan to use the API. Knowing how the community is using the API will help us to shape future development on it.

When you click the 'Request a Key' button, you will be directed to page confirming that we've received your request. As soon as possible, we will review your request and grant access to the Springpad API. At this time, you'll receive the credentials you need to get started with the API. The email will look something like this:

-

This email provides you with your consumer key and consumer secret. Store these for future reference. For username/password authentication, you will use just the consumer key to identify your application to Springpad. Both are necessary for OAuth authentication. We will discuss each type of authentication in turn next.

Simple Authentication

For simple one-off requests or exploratory coding, we support a username/password-based method of authentication. To do this, simply include X-Spring-Username and X-Spring-Password in the header of each HTTP request to the server with the username and password for the account you are accessing. Additionally, include X-Spring-Api-Token in the header with your consumer key. Alternatively, you can pass the username or password in request parameters. This will not be permitted for a large volume of requests. Once you are ready to release something for public consumption, you will need to authenticate with OAuth.

OAuth Authentication

OAuth is a widely-accepted, open protocol for secure authentication with webservice APIs. It not only provides a secure method of authentication but also safeguards the user's password from 3rd parties. There are several steps to authenticating with a server using OAuth, so we'll walk through the process step-by-step. Example code is also available in our python client library. In order to authenticate using OAuth, you need to request access to a user's data using your application identifiers (consumer key and consumer secret). Springpad will respond with a request token which you use to direct the user to a URL on the Springpad server that will allow them to grant your application access to their information. When they've granted it, you can then use the request token to get a permanent access token for that user. That token is then included in all API requests to identify the user. It is valid until the user revokes it.

Step 1: Getting a request token

The first thing your application needs to do to gain access to a user's Springpad data is to get a request token from the Springpad server. To perform OAuth authentication, you will need to use an OAuth library for your language, probably available here. Our examples will use the python implementation. Once you have downloaded and installed the oauth library, you simple need to send an HTTP GET request to http://springpad.com/developers/oauth/register-app with a request signed with your consumer key and consumer secret.

In the following code, we create an HTTP GET request to get the request-token from Springpad and then parse the response saving the token in the request_token variable.

import oauth.oauth as oauth
import httplib2 

CONSUMER_KEY = '72c99068dbff4bc68a8d98eb4b17d734'
CONSUMER_PRIVATE = '9313227b97244a76bd0508322dd61f60'

consumer = oauth.OAuthConsumer(CONSUMER_KEY, CONSUMER_PRIVATE)
request = oauth.OAuthRequest.from_consumer_and_token(consumer, token=None, 
                                                     http_url="http://springpad.com/api/oauth-request-token",
                                                     http_method='GET')
signature_method = oauth.OAuthSignatureMethod_HMAC_SHA1()
request.sign_request(signature_method, consumer, None)
url = request.to_url()
response, data = httplib2.Http().request(url) 
request_token = oauth.OAuthToken.from_string(data)
Step 2: Redirect the user to Springpad's access page

With the request token, now redirect the user to Springpad where they will be asked to grant your application access. In the following code sample, we create the URL to direct the user to.

url = "http://springpad.com/api/oauth-authorize%?s" % request_token
 # produces: http://springpad.com/api/oauth-authorize?oauth_token_secret=0e71505050ab9c685b7b85aa37cb95cd&oauth_token=d51e15710bfee0a680cf06325b8fcb27
Step 3: Get the access token

When the user approves access to your service, Springpad will redirect the user to the callback URL you provided during the request process with the request token as a parameter. Once the callback URL is hit, you can request the access token from Springpad using the request token as the access token. In the following code sample, we create a request for the access token and then save the access token based on the response.

import oauth.oauth as oauth
import httplib2 
consumer = oauth.OAuthConsumer(CONSUMER_KEY, CONSUMER_PRIVATE)
request = oauth.OAuthRequest.from_consumer_and_token(consumer, token=request_token, 
                                                     http_url="http://springpad.com/api/oauth-access-token",
                                                     http_method='GET')
signature_method = oauth.OAuthSignatureMethod_HMAC_SHA1()
request.sign_request(signature_method, consumer, request_token)
url = request.to_url()
response, data = httplib2.Http().request(url) 
access_token = oauth.OAuthToken.from_string(data)
Step 4: Signing subsequent requests to Springpad

Now that you've gotten the access token for the user, you simply need to sign each request much like you did in the previous step, except with the access token, rather than the request token. For example:

import oauth.oauth as oauth
import httplib2 
consumer = oauth.OAuthConsumer(CONSUMER_KEY, CONSUMER_PRIVATE)
request = oauth.OAuthRequest.from_consumer_and_token(consumer, token=access_token, 
                                                     http_url="http://springpad.com/api/users/me/blocks?limit=25&sort=created",
                                                     http_method='GET')
signature_method = oauth.OAuthSignatureMethod_HMAC_SHA1()
request.sign_request(signature_method, consumer, access_token)
url = request.to_url()
response, data = httplib2.Http().request(url)

Jsonp

For all requests you can specify a jsonp parameter with a callback function name to use JSONP. This will wrap the output in a function call to the specified function. Either 'jsonp' or 'callback' will work as the parameter name.

Accessing Blocks

This section describes the API for accessing blocks in the system, both those belonging to the user as well as those from other Springpad users and from the web.

/users/{username}/blocks/{uuid} Returns the block for the given UUID
Path Parameters
  • username Either the username of the owner of the block or ‘me’ if an authentication token is being passed with the request
  • uuid The uuid of the block being fetched
Query Parameters
  • format determines the format of the result returned by the server. See formatting discussion.
Returns a JSON represention of the Block with that UUID or an error if it doens't exist. See Block Formatting for more detail.
/users/{username}/blocks Returns the blocks matching the request. (configure the search terms with the query parameters)
Path Parameters
  • username Either the username of the owner of the blocks or ‘me’ if auth token is being passed
Query Parameters
  • type name of the Type to restrict the results to. (Member Blocks will be returned regardless of type. For example, if type=Restaurant is specified, Address-typed Blocks will still be returned nested in the restaurants.)
  • filter a boolean expression to filter the result set on block properties. See below for filters used for filtering. For example, ‘cuisine_ms=French and metadata-personalRating_d>3’. This parameter should be url encoded.’
  • text text to match to the block. This searches the name as well as properties of the block.
  • sort specifies the sort order for the result set.
  • order specifies whether to sort in ascending or desceding order.
  • start returns results starting with the nth result. This can be used in conjunction with the limit parameter to iterate through large result sets.
  • limit maximum number of results to return.
  • format determines the format of the result set returned from the server. See discussion of formats.
Returns a JSON represention of the blocks matched by the query. See Block Formatting for more detail on the format of the results.

Filters:

  • type Counts all of the types such as Restaurants or Notes, etc.
  • tag Tags
  • userAction values are “ToDo” or “Done” indicating that the user either wants the item or has the item
  • flagged True if flagged, false if not
  • workbook Counts the number of item per notebook (internally we use workbook for notebooks)
  • public True if public otherwise private
  • personalRating Star ratings for all blocks
  • sourceService Service that the block came from (ie. Facebook, Netflix)
  • mainIngredient For Recipes
  • cuisine or cuisine Cuisine for Restaurants or Recipes
  • winteType For Wines
  • varietal For Wines
  • region For Wines
  • price For Products
  • manufacturer For Products, manufacturer or brand
  • artist For Album
  • genres For Album, Book
  • author For Book
  • cast For Movie, TVShow
  • directors For Movie, TVShow
  • producers For Movie, TVShow
  • season For TVShow
  • complete For Task
  • isInPast For Task
  • neighborhood For Restaurant

/blocks/all Searches the web and other Springpad users for blocks of all types matching the request's parameters. This can be used to find new blocks for the user's account.
Query Parameters
  • text text to search for on the block. If a location is appended to this parameter it will be used to do a geo search. (e.g. ‘coffee shops, palo alto, CA’).
  • limit limits the number of results to return
  • lat specifies a the latitude as a part of geo-search. this must be used in conjunction with lng
  • lng specifies the longitude as a part of a geo-search. this must be used in conjunction with lat
  • format determines the format of the result set returned from the server. See discussion of formats.
This returns a JSON map with a 'blocks' property yielding an array of results. http://springpad.com/api/blocks/all?limit=2&text='hitchhikers%20guide%20douglas%20adams'
{
"blocks": [
{
    "properties": {
        "userAction": "ToDo",
        "url": "http://www.netflix.com/Movie/The_Hitchhiker_s_Guide_to_the_Galaxy/60022509",
        "image": "http://cdn-9.nflximg.com/us/boxshots/large/60022509.jpg",
        "netflixUpdated": True,
        "releaseDate": "1981",
        "sources": ["netflix:http://www.netflix.com/Movie/The_Hitchhiker_s_Guide_to_the_Galaxy/60022509"],
        "netflixId": "http://api-public.netflix.com/catalog/titles/series/60022509",
        "services": ["netflix:http://api-public.netflix.com/catalog/titles/series/60022509"]
    },
    "type": "/Type(Movie)/",
    "modified": "/Date(1277752381796)/",
    "name": "The Hitchhiker's Guide to the Galaxy",
    "created": "/Date(1277752381795)/"
}]
}
Results from this search can be a public Block in a Springpad user's account, in which case it will include a UUID for the block and some creator information, or Block retrieved from the web (e.g., Yelp, Amazon, Netflix, etc.). The latter Blocks do not have a UUID associated with them but can be retrieved individually using the services array. The keys can be be used to add the block to the current user's account or spring it by doing an HTTP POST with the keys included as a JSON array in the POST body using the /springit API call.
/blocks/types/{type}/all Returns all blocks of the specified type matching the query parameters.
Path Parameters
  • type block type
Query Parameters
  • text text to search for on the block. If a location is appended to this parameter it will be used to do a geo search. (e.g. ‘coffee shops, palo alto, CA’).
  • limit limits the number of results to return
  • lat specifies a the latitude as a part of geo-search. this must be used in conjunction with lng
  • lng specifies the longitude as a part of a geo-search. this must be used in conjunction with lat
  • format determines the format of the result set returned from the server. See discussion of formats.
The format of the result set is the same as for the */blocks/all* call.

Data Format

In this section, we will discuss the data format that the Springpad API uses. As has already been mentioned, the Springpad API uses JSON to format result sets. And HTTP POST data should also be formatted using JSON. The following section applies to those two cases. First, we will discuss the format of different types of values that you will receive from the Springpad. That format is also how you should send those values in your POST bodies. Then, we will show the different formats for result sets available from the API.

Value Formats

For the most part, the Springpad API uses the same format for values as JSON. So the numbers, strings, and arrays output by your JSON library will work seemlessly with Springpad. For example here is an array with some numbers and strings in it that will work with the Springpad API.

["here is a string", 23, "that was a number", 3.14, "that was another number", ""]

However, since there are no built-in standard Dates or UUIDs so we defined a protocol to reference them. We use a similar one to reference Springpad Types. To denote a date or datetime, simple create a string with the format: “/Date(t)/” where t = milliseconds since January 1, 1970, 00:00:00 GMT. For example:

"/Date(1272169340040)/"

Similarly, UUIDs are strings formatted as: “/UUID (uuid)/” where uuid is the UUID’s string representation. Another important thing to note about UUIDs is that Springpad uses uses the first 3 characters of the UUID in specific ways. So if you are creating your own UUID for a new block be sure to attend to the following rules.

  1. The first two characters of the UUID string must be the user’s shard, which can be accessed by the /users/{userid} API method or by taking the first two characters of any of the user’s block’s UUIDs.
  2. The third character of the UUID string indicates the type of the object. 1 is for Type, 3 for Block, and 4 for User.
    So the UUID in the following example is for a Block whose user’s shard is ‘05’.
"/UUID(053d19eb-db67-4597-82bc-8a9ee48ff855)/"

References to Springpad types are simply strings formatted as “/Type(typeName)/”. So the following example is a reference to the Note type.

"/Type(Note)/"
Block Result Set Formats

You can request data from Springpad in four different formats. The data is always returned as JSON, but format selection determines how much data is returned from simply IDs to a full representation of the block based. This can enable efficient network-usage while accessing large volumes of data. We discuss each format in turn.

ids

This is the most minimal format, simply returning a set of UUIDs for the blocks matched by the request. The UUID can be used to query for the block individually afterwards.

[{"uuid": "/UUID(05308a01-860f-49db-b33a-eb519c087c90)/"}, {"uuid": "/UUID(0530aa05-467b-4c2b-9480-16ce11eeb0cc)/"}]
minimal

This format returns slightly more information, including the name and type of the Block as well some information about the owner.

[{"uuid": "/UUID(05308a01-860f-49db-b33a-eb519c087c90)/",
"creatorUsername": "aykroyd",
"creatorPicture": "http://springpad-user-data.s3.amazonaws.com/05/0544ca2d-7fb2-433e-86af-2ff16b9c8f65/053ec38f-41b9-44e3-910d-2421cb9a6e7a-thumb/upload-05-8a7cc6e31d931fe1011d972029565e4457981.tmp",
"created": "/Date(1270233039967)/",
"modified": "/Date(1272232317382)/",
"creator": "/UUID(0544ca2d-7fb2-433e-86af-2ff16b9c8f65)/",
"publicUrl": "restaurant/pizzamyheart",
"type": "/Type(Restaurant)/",
"name": "Pizza My Heart"},
  {"uuid": "/UUID(0530aa05-467b-4c2b-9480-16ce11eeb0cc)/",
"creatorUsername": "aykroyd",
"creatorPicture": "http://springpad-user-data.s3.amazonaws.com/05/0544ca2d-7fb2-433e-86af-2ff16b9c8f65/053ec38f-41b9-44e3-910d-2421cb9a6e7a-thumb/upload-05-8a7cc6e31d931fe1011d972029565e4457981.tmp",
"created": "/Date(1272169340038)/",
"modified": "/Date(1272232260532)/",
"creator": "/UUID(0544ca2d-7fb2-433e-86af-2ff16b9c8f65)/",
"publicUrl": "restaurant/cafecolucci",
"type": "/Type(Restaurant)/",
"name": "Cafe Colucci"}]
preview

Preview is very similar to the minimal format. It adds a subtitle field. This was added to support being able to show a rich list view for the item without fetching the entire block.

[{"subtitle": "220 University Ave, Palo Alto, CA 94301",
"uuid": "/UUID(05308a01-860f-49db-b33a-eb519c087c90)/",
"creatorUsername": "aykroyd",
"creatorPicture": "http://springpad-user-data.s3.amazonaws.com/05/0544ca2d-7fb2-433e-86af-2ff16b9c8f65/053ec38f-41b9-44e3-910d-2421cb9a6e7a-thumb/upload-05-8a7cc6e31d931fe1011d972029565e4457981.tmp",
"image": "http://springpad-user-data.s3.amazonaws.com/05/0544ca2d-7fb2-433e-86af-2ff16b9c8f65/05308a01-860f-49db-b33a-eb519c087c90/05308a01-860f-49db-b33a-eb519c087c90-perm-thumb.png",
"created": "/Date(1270233039967)/",
"modified": "/Date(1272232317382)/",
"creator": "/UUID(0544ca2d-7fb2-433e-86af-2ff16b9c8f65)/",
"services": ["yelp:6503279400", "sourceUrl:http%3A%2F%2Fwww.yelp.com%2Fbiz%2Fpizza-my-heart-palo-alto"],
"publicUrl": "restaurant/pizzamyheart",
"type": "/Type(Restaurant)/",
"name": "Pizza My Heart"},
{"subtitle": "6427 Telegraph Ave, Oakland, CA 94609",
"uuid": "/UUID(0530aa05-467b-4c2b-9480-16ce11eeb0cc)/",
"creatorUsername": "aykroyd",
"creatorPicture": "http://springpad-user-data.s3.amazonaws.com/05/0544ca2d-7fb2-433e-86af-2ff16b9c8f65/053ec38f-41b9-44e3-910d-2421cb9a6e7a-thumb/upload-05-8a7cc6e31d931fe1011d972029565e4457981.tmp",
"image": "http://springpad-user-data.s3.amazonaws.com/05/0544ca2d-7fb2-433e-86af-2ff16b9c8f65/0530aa05-467b-4c2b-9480-16ce11eeb0cc/0530aa05-467b-4c2b-9480-16ce11eeb0cc-perm-thumb.png",
"created": "/Date(1272169340038)/",
"modified": "/Date(1272232260532)/",
"creator": "/UUID(0544ca2d-7fb2-433e-86af-2ff16b9c8f65)/",
"services": ["yelp:5106017999", "phone:5106017999", "sourceUrl:http%3A%2F%2Fwww.yelp.com%2Fbiz%2Fcafe-colucci-oakland"],
"publicUrl": "restaurant/cafecolucci",
"type": "/Type(Restaurant)/",
"name": "Cafe Colucci"}]
full

This format includes all of the block information and nests any blocks belonging to it as properties.

[{"uuid": "/UUID(05308a01-860f-49db-b33a-eb519c087c90)/",
"creatorUsername": "aykroyd",
"creatorPicture": "http://springpad-user-data.s3.amazonaws.com/05/0544ca2d-7fb2-433e-86af-2ff16b9c8f65/053ec38f-41b9-44e3-910d-2421cb9a6e7a-thumb/upload-05-8a7cc6e31d931fe1011d972029565e4457981.tmp",
"created": "/Date(1270233039967)/",
"modified": "/Date(1272232317382)/",
"creator": "/UUID(0544ca2d-7fb2-433e-86af-2ff16b9c8f65)/",
"publicUrl": "restaurant/pizzamyheart",
"type": "/Type(Restaurant)/",
"properties": {
    "userAction": "Done",
    "services": ["yelp:6503279400", "sourceUrl:http%3A%2F%2Fwww.yelp.com%2Fbiz%2Fpizza-my-heart-palo-alto"],
    "contactInfo": [{
        "uuid": "/UUID(05300d53-fe17-45d6-9f2e-8ec895f355f9)/",
        "created": "/Date(1270233039969)/",
        "creator": "/UUID(0544ca2d-7fb2-433e-86af-2ff16b9c8f65)/",
        "modified": "/Date(1270233040080)/",
        "type": "/Type(Address)/",
        "properties": {
            "city": "Palo Alto",
            "zip": "94301",
            "text": "220 University Ave, Palo Alto, CA 94301",
            "state": "CA",
            "street": "220 University Ave",
            "lat": 37.444801330566399,
            "lng": -122.16300201416
        }
    },
    {
        "uuid": "/UUID(05382fed-92f2-4c59-a11b-1cf4c9e9341d)/",
        "created": "/Date(1270233040081)/",
        "creator": "/UUID(0544ca2d-7fb2-433e-86af-2ff16b9c8f65)/",
        "modified": "/Date(1270233040084)/",
        "type": "/Type(Account)/",
        "properties": {
            "username": "http://www.yelp.com/biz/pizza-my-heart-palo-alto",
            "type": "Website"
        }
    },
    {
        "uuid": "/UUID(053025b7-78de-410f-a5a5-985b7b4920f1)/",
        "created": "/Date(1270233040084)/",
        "creator": "/UUID(0544ca2d-7fb2-433e-86af-2ff16b9c8f65)/",
        "modified": "/Date(1270233040087)/",
        "type": "/Type(Phone)/",
        "properties": {
            "number": "6503279400"
        }
    }],
    "thumbKey": "05/0544ca2d-7fb2-433e-86af-2ff16b9c8f65/05308a01-860f-49db-b33a-eb519c087c90/05308a01-860f-49db-b33a-eb519c087c90-perm-thumb.png"
},
"name": "Pizza My Heart"},
{"uuid": "/UUID(0530aa05-467b-4c2b-9480-16ce11eeb0cc)/",
"creatorUsername": "aykroyd",
"creatorPicture": "http://springpad-user-data.s3.amazonaws.com/05/0544ca2d-7fb2-433e-86af-2ff16b9c8f65/053ec38f-41b9-44e3-910d-2421cb9a6e7a-thumb/upload-05-8a7cc6e31d931fe1011d972029565e4457981.tmp",
"created": "/Date(1272169340038)/",
"modified": "/Date(1272232260532)/",
"creator": "/UUID(0544ca2d-7fb2-433e-86af-2ff16b9c8f65)/",
"publicUrl": "restaurant/cafecolucci",
"type": "/Type(Restaurant)/",
"properties": {
    "userAction": "Done",
    "attachments": [{
        "uuid": "/UUID(0534e7be-7012-4eb1-a4ab-84e14dc49437)/",
        "creatorUsername": "aykroyd",
        "creatorPicture": "http://springpad-user-data.s3.amazonaws.com/05/0544ca2d-7fb2-433e-86af-2ff16b9c8f65/053ec38f-41b9-44e3-910d-2421cb9a6e7a-thumb/upload-05-8a7cc6e31d931fe1011d972029565e4457981.tmp",
        "created": "/Date(1272231770675)/",
        "modified": "/Date(1272231770743)/",
        "creator": "/UUID(0544ca2d-7fb2-433e-86af-2ff16b9c8f65)/",
        "type": "/Type(Note)/",
        "properties": {
            "text": "Pretty awesome menu.",
            "isAttachment": True,
            "rich": True
        },
        "publicUrl": "note/unnamednote/d5b"
    }],
    "personalRating": 3.0,
    "image": "http://static1.px.yelpcdn.com/bpthumb/lmtzQCPjI_BOGngu9wNrOg/ms",
    "sources": ["yelp:http://www.yelp.com/biz/cafe-colucci-oakland"],
    "services": ["yelp:5106017999", "phone:5106017999", "sourceUrl:http%3A%2F%2Fwww.yelp.com%2Fbiz%2Fcafe-colucci-oakland"],
    "contactInfo": [{
        "uuid": "/UUID(0537627a-4687-4778-b934-600d22b0f8c8)/",
        "created": "/Date(1272169340039)/",
        "creator": "/UUID(0544ca2d-7fb2-433e-86af-2ff16b9c8f65)/",
        "modified": "/Date(1272169340041)/",
        "type": "/Type(Address)/",
        "properties": {
            "city": "Oakland",
            "zip": "94609",
            "text": "6427 Telegraph Ave, Oakland, CA 94609",
            "state": "CA",
            "street": "6427 Telegraph Ave",
            "lat": 37.850723000000002,
            "lng": -122.260447
        }
    },
    {
        "uuid": "/UUID(0534f154-a98d-4fac-b61a-12375ab34b82)/",
        "created": "/Date(1272169340041)/",
        "creator": "/UUID(0544ca2d-7fb2-433e-86af-2ff16b9c8f65)/",
        "modified": "/Date(1272169340043)/",
        "type": "/Type(Account)/",
        "properties": {
            "username": "http://www.yelp.com/biz/cafe-colucci-oakland",
            "type": "Website"
        }
    },
    {
        "uuid": "/UUID(053d19eb-db67-4597-82bc-8a9ee48f1855)/",
        "created": "/Date(1272169340043)/",
        "creator": "/UUID(0544ca2d-7fb2-433e-86af-2ff16b9c8f65)/",
        "modified": "/Date(1272169340045)/",
        "type": "/Type(Phone)/",
        "properties": {
            "number": "5106017999"
        }
    }],
    "thumbKey": "05/0544ca2d-7fb2-433e-86af-2ff16b9c8f65/0530aa05-467b-4c2b-9480-16ce11eeb0cc/0530aa05-467b-4c2b-9480-16ce11eeb0cc-perm-thumb.png"
},
"name": "Cafe Colucci"}]

Accessing Counts of Blocks

This section discusses how to obtain different kinds of counts of blocks in a user's account.

/users/{username}/blocks/count/{attribute} HTTP GET method that will get counts for things in the user's account
Path Parameters
  • username username or ‘me’
  • attribute The thing you are trying to count, ie. type or tag, see “Filters” above. Also * will count everything we can count in the user’s data
The response is json like this:
{
"source_ms":
  {
  "netflix":1
  },
"userAction_s":
  {
  "ToDo":1
  },
"tag":
  {
  "favorites":1
  },
"metadata-personalRating_d":
  {
  "0.0":32,
  "4.0":1
  },
"isInPast_b":
  {
  "false":16,
  "true":1
  },
"flagged_b":
  {
  "false":32,
  "true":1
  },
"workbook_ms":
  {
  "08377a3d-2c33-42ce-897b-10c189854d76":1,
  "0839b864-b572-4e14-9fd0-4ef0c5fc78f9":1
  },
"complete_b":
  {
  "false":15
  },
"cast_ms":
  {
  "Al Pacino":1,
  "Diane Keaton":1,
  "Marlon Brando":1,
  "Richard Castellano":1,
  "Robert Duvall":1
  },
"type":
  {
  "lifemanagr.Task":15,
  "lifemanagr.Note":14,
  "lifemanagr.Appointment":2,
  "lifemanagr.Movie":1,
  "lifemanagr.GeneralList":1
  },
"metadata-public_b":
  {
  "true":1,
  "false":32
  },
"directors_ms":
  {
  "Francis Ford Coppola":1
  }
}

Adding, Modifying, and Deleting Blocks

This section discusses how to modify or create blocks in a user's account.

/springit HTTP POST method that will add the Block identified in the message body to the authenticated user's account
If springing a block that is already in the system (owned by another user) the POST body should contain a JSON array with the UUID string of the block to spring. Otherwise, the POST body should contain the services array of the block being sprung.
/users/{username}/commands HTTP POST method that uses the message body to pass a set of commands to run on the user's account.
Path Parameters
  • username username or ‘me’
Commands are formatted as a JSON array of commands, where the commands are arrays with each element representing an argument. The format of these commands is discussed below. Create
["create", {typename}, {uuid}]
  • typename The type name of the Block to create
  • uuid the uuid for the block being created. Please note, the UUID for the block, ensure that the first two characters in it match the user’s shard (accessible with the /users/{userid} API call) and that the third character is always ‘3’. If the UUID does not meet these requirements the request will fail.
["create", "Restaurant", "/UUID(053d19eb-db67-4597-82bc-8a9ee48f1855)/"]
for a user with shard ID "05" Delete
["delete", {uuid}]
  • uuid UUID of the block to delete
Set
["set", {uuid}, {propertyName}, {value}]
  • uuid UUID of the block
  • propertyName Property being set
  • value The value being set on the block, properly encoded. Note that dates are encoded with the format: “/Date({milliseconds})/” where milliseconds is the number of milliseconds since January 1, 1970, 00:00:00 GMT (the same as Java uses for its Date object). Similarly uuids are encoded as “/UUID/”.
Examples:
[["set", "/UUID(053d19eb-db67-4597-82bc-8a9ee48f1855)/", "name", "My Favorite Book"],
["set", "/UUID(053d19eb-db67-4597-82bc-8a9ee48f1855)/", "date", "/Date(1272169340040)/"],
["set", "/UUID(053d19eb-db67-4597-82bc-8a9ee48f1855)/", "relatedBlock", "/UUID(053d19eb-db67-4597-82bc-8a9ee48ff855)/"],
["set", "/UUID(053d19eb-db67-4597-82bc-8a9ee48f1855)/", "number", 42.0]]
Add
["add", {uuid}, {propertyName}, {value}]
  • uuid UUID of the block
  • propertyName List property being appended to
  • value Properly encoded value. See discussion in Set.
Remove
["remove", {uuid}, {propertyName}, {value}]
  • uuid UUID of the Block
  • propertyName List property being removed from
  • value Value to remove, properly encoded.
SpringIt
["spring", {id}, {isAttachment}]
  • id UUID of the Block to spring or the sbr id with the “sbr:” prefix
  • isAttachment true if it is an attachment otherwise can be omitted
Move
["move", {uuid}, {propertyName}, {value}, {toIndex}]
  • uuid UUID of the Block being modified
  • propertyName Name of the property
  • value Properly encoded value being moved.
  • toIndex Index to move the value to.

Accessing User Info

/users/{userid} Returns information about the user. More detailed information if the user is the one that is authenticated
Path Parameters
  • userid Either the username or uuid for the user being queried
If the request is for the user that is currently authenticated, then more data is returned by the server including shard, number of blocks, timezone, last login, etc.
{"username": "john_doe",
"confirmed": True,
"uuid": "/UUID(0544cb9d-7fb2-433e-86af-2ff16b9c8f65)/",
"firstName": "John",
"created": "/Date(1226601146638)/",
"lastName": "Doe"",
"lastLoggedIn": "/Date(1277746320931)/",
"shard": "03",
"email": "john.doe@nowhere.com",
"blockCount": 42,
"active": True,
"timeZone": "PST",
"nickname": "john",
"profilePicture": "http://springpad-user-data.s3.amazonaws.com/03/0544cb9d-7fb2-433e-86af-2ff16b9c8f65/053ec38f-41b9-44e3-910d-2421cb9a6e7a-thumb/upload-05-8a7cc6e31d931fe1011d972029565e4333.tmp",
"timeZoneOffset": -25200000}
Requesting information about another user results in less information.
{"username": "springpartners",
"profilePicture": "http://springpad-user-data.s3.amazonaws.com/02/0243dd1e-02d9-48f6-967e-085928e60f62/023d0260-6e69-4f90-889f-25bf8de69f97-thumb/upload-02-null47781.tmp",
"nickname": "springpartners",
"uuid": "/UUID(0243dd1e-02d9-48f6-967e-085928e60f62)/",
"created": "/Date(1242078097741)/"}

Springpad Types

Account
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
Boolean
primary
default:false
String
owner
String
type
values: Email, Website, IM
String
provider
String
urlText
String
username
String
label
Address
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
Boolean
primary
default:false
String
text
Number
lat
Number
long
String
street
String
street2
deprecated
String
city
String
state
default:--
String
zip
Alarm
Properties
String
name
default:New Alarm
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
default:not-public
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
String
description
List
reminders
String
publicBlurb
Number
personalRating
List of Uuid
workbooks
List of Uuid
/block/commenters
Map
/block/commenters_workbook_count
Number
/meta/heart_count
readonly
List of Map
user_service_actions
Date
/user/updated
List
attachments
List of Uuid
/hidden/updated_attachments
Boolean
isAttachment
String
userAction
default:ToDo values: ToDo, Done
String
image
List of String
tags
Boolean
flagged
List of Note
publicComments
List of Note
privateComments
metadata
readonly
frequency
Boolean
enabled
default:true
String
notes
nextFireTime
lastFireTime
readonly
List of Channel
channels
Date
scheduled
readonly
List of String
forcePush
Album
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
default:not-public
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
String
description
List
reminders
String
publicBlurb
Number
personalRating
List of Uuid
workbooks
List of Uuid
/block/commenters
Map
/block/commenters_workbook_count
Number
/meta/heart_count
readonly
List of Map
user_service_actions
Date
/user/updated
List
attachments
List of Uuid
/hidden/updated_attachments
Boolean
isAttachment
String
userAction
default:ToDo values: ToDo, Done
String
image
List of String
tags
Boolean
flagged
List of Note
publicComments
List of Note
privateComments
metadata
readonly
String
artist
String
releaseDate
String
format
List of String
genres
List of Track
tracks
String
price
List of String
recordLabels
Audio
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
default:not-public
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
String
/media/file_name
String
/media/mime_type
String
url
String
description
String
key
readonly
metadata
readonly
List of Map
image_assets
List of Map
audio_assets
List of Map
video_assets
List
reminders
String
publicBlurb
Number
personalRating
List of Uuid
workbooks
List of Uuid
/block/commenters
Map
/block/commenters_workbook_count
Number
/meta/heart_count
readonly
List of Map
user_service_actions
Date
/user/updated
List
attachments
List of Uuid
/hidden/updated_attachments
Boolean
isAttachment
String
userAction
default:ToDo values: ToDo, Done
String
image
List of String
tags
Boolean
flagged
List of Note
publicComments
List of Note
privateComments
Number
/audio/duration
BetaFeature
Properties
String
name
String
method
BlockMetadata
Properties
String
name
String
/meta/published
Number
timesSprung
readonly
Number
directTimesSprung
readonly
Number
originalTimesSprung
readonly
String
sourceClient
readonly
String
sourceService
readonly
String
sourceAction
readonly
String
publicUrl
readonly
String
privateUrl
readonly
Book
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
default:not-public
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
String
description
List
reminders
String
publicBlurb
Number
personalRating
List of Uuid
workbooks
List of Uuid
/block/commenters
Map
/block/commenters_workbook_count
Number
/meta/heart_count
readonly
List of Map
user_service_actions
Date
/user/updated
List
attachments
List of Uuid
/hidden/updated_attachments
Boolean
isAttachment
String
userAction
default:ToDo values: ToDo, Done
String
image
List of String
tags
Boolean
flagged
List of Note
publicComments
List of Note
privateComments
metadata
readonly
String
author
String
publicationDate
String
cover
Number
pages
List of String
genres
String
level
Number
isbn
Number
isbn_13
String
price
Bookmark
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
default:not-public
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
String
description
List
reminders
String
publicBlurb
Number
personalRating
List of Uuid
workbooks
List of Uuid
/block/commenters
Map
/block/commenters_workbook_count
Number
/meta/heart_count
readonly
List of Map
user_service_actions
Date
/user/updated
List
attachments
List of Uuid
/hidden/updated_attachments
Boolean
isAttachment
String
userAction
default:ToDo values: ToDo, Done
String
image
List of String
tags
Boolean
flagged
List of Note
publicComments
List of Note
privateComments
metadata
readonly
String
text
String
url
Business
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
default:not-public
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
List
addresses
List
contactInfo
List
accounts
String
neighborhood
String
description
List
reminders
String
publicBlurb
Number
personalRating
List of Uuid
workbooks
List of Uuid
/block/commenters
Map
/block/commenters_workbook_count
Number
/meta/heart_count
readonly
List of Map
user_service_actions
Date
/user/updated
List
attachments
List of Uuid
/hidden/updated_attachments
Boolean
isAttachment
String
userAction
default:ToDo values: ToDo, Done
String
image
List of String
tags
Boolean
flagged
List of Note
publicComments
List of Note
privateComments
metadata
readonly
Channel
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
Boolean
primary
default:false
String
destination
String
type
default:email
String
sourceUuid
contact
Boolean
authenticated
default:false
Boolean
disabled
String
deviceId
Boolean
/channel/notifications/springpad_news
Boolean
/channel/notifications/reminders
Boolean
/channel/notifications/block_to_phone
Boolean
/channel/notifications/new_followers
Boolean
/channel/notifications/new_notebook_followers
Boolean
/channel/notifications/springs
Boolean
/channel/notifications/owned_block_comments
Boolean
/channel/notifications/others_block_comments
Boolean
/channel/notifications/invitations
Boolean
/channel/notifications/likes
Boolean
/channel/notifications/digest
Check List
Properties
String
name
default:New Check List
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
default:not-public
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
String
description
List
reminders
String
publicBlurb
Number
personalRating
List of Uuid
workbooks
List of Uuid
/block/commenters
Map
/block/commenters_workbook_count
Number
/meta/heart_count
readonly
List of Map
user_service_actions
Date
/user/updated
List
attachments
List of Uuid
/hidden/updated_attachments
Boolean
isAttachment
String
userAction
default:ToDo values: ToDo, Done
String
image
List of String
tags
Boolean
flagged
List of Note
publicComments
List of Note
privateComments
metadata
readonly
items
Check List Item
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
Boolean
complete
CollabMember
Properties
String
name
Uuid
/member/uuid
String
/member/status
String
/member/image
String
/member/username
String
/member/invite_code
/member/workbook
String
/member/email
Contact
Properties
String
name
default:New Contact
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
default:not-public
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
List
addresses
List
contactInfo
List
accounts
String
neighborhood
String
description
List
reminders
String
publicBlurb
Number
personalRating
List of Uuid
workbooks
List of Uuid
/block/commenters
Map
/block/commenters_workbook_count
Number
/meta/heart_count
readonly
List of Map
user_service_actions
Date
/user/updated
List
attachments
List of Uuid
/hidden/updated_attachments
Boolean
isAttachment
String
userAction
default:ToDo values: ToDo, Done
String
image
List of String
tags
Boolean
flagged
List of Note
publicComments
List of Note
privateComments
metadata
readonly
String
title
String
company
Date
Properties
Date
date
DateTimeObject
Sub-type of:
Properties
Date
date
Email
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
String
email
Event
Properties
String
name
default:New Event
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
default:not-public
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
List
addresses
String
description
List
reminders
String
publicBlurb
Number
personalRating
List of Uuid
workbooks
List of Uuid
/block/commenters
Map
/block/commenters_workbook_count
Number
/meta/heart_count
readonly
List of Map
user_service_actions
Date
/user/updated
List
attachments
List of Uuid
/hidden/updated_attachments
Boolean
isAttachment
String
userAction
default:ToDo values: ToDo, Done
String
image
List of String
tags
Boolean
flagged
List of Note
publicComments
List of Note
privateComments
metadata
readonly
List
assignees
Boolean
allDay
frequency
String
url
String
note
List
addressReferences
nextFireTime
toNextFireTime
lastFireTime
readonly
Fax
Sub-type of:
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
Boolean
primary
default:false
String
type
values: Home Phone, Mobile Phone, Work Phone, Other Phone
String
number
File
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
default:not-public
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
String
/media/file_name
String
/media/mime_type
String
url
String
description
String
key
readonly
metadata
readonly
List of Map
image_assets
List of Map
audio_assets
List of Map
video_assets
List
reminders
String
publicBlurb
Number
personalRating
List of Uuid
workbooks
List of Uuid
/block/commenters
Map
/block/commenters_workbook_count
Number
/meta/heart_count
readonly
List of Map
user_service_actions
Date
/user/updated
List
attachments
List of Uuid
/hidden/updated_attachments
Boolean
isAttachment
String
userAction
default:ToDo values: ToDo, Done
String
image
List of String
tags
Boolean
flagged
List of Note
publicComments
List of Note
privateComments
Frequency
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
String
repeat
default:Never values: Never, daily, weekdays, weekly, montly, yearly
Number
repeatEvery
default:1.0
Boolean
repeatOnMo
Boolean
repeatOnTu
Boolean
repeatOnWe
Boolean
repeatOnTh
Boolean
repeatOnFr
Boolean
repeatOnSa
Boolean
repeatOnSu
Boolean
repeatDayOfWeek
Boolean
repeatDayOfMonth
default:true
Milestone (deprecated)
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
default:not-public
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
String
description
List
reminders
String
publicBlurb
Number
personalRating
List of Uuid
workbooks
List of Uuid
/block/commenters
Map
/block/commenters_workbook_count
Number
/meta/heart_count
readonly
List of Map
user_service_actions
Date
/user/updated
List
attachments
List of Uuid
/hidden/updated_attachments
Boolean
isAttachment
String
userAction
default:ToDo values: ToDo, Done
String
image
List of String
tags
Boolean
flagged
List of Note
publicComments
List of Note
privateComments
metadata
readonly
date
frequency
List of Contact
contacts
List of File
files
Boolean
singular
default:false
Movie
Properties
String
name
default:New movie...
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
default:not-public
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
List of String
cast
List of String
directors
List of String
writers
List of String
producers
String
rating
String
thumbUrl
String
plot
List of String
awards
String
description
List
reminders
String
publicBlurb
Number
personalRating
List of Uuid
workbooks
List of Uuid
/block/commenters
Map
/block/commenters_workbook_count
Number
/meta/heart_count
readonly
List of Map
user_service_actions
Date
/user/updated
List
attachments
List of Uuid
/hidden/updated_attachments
Boolean
isAttachment
String
userAction
default:ToDo values: ToDo, Done
String
image
List of String
tags
Boolean
flagged
List of Note
publicComments
List of Note
privateComments
metadata
readonly
String
runTime
String
releaseDate
Musician/Band
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
default:not-public
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
String
description
List
reminders
String
publicBlurb
Number
personalRating
List of Uuid
workbooks
List of Uuid
/block/commenters
Map
/block/commenters_workbook_count
Number
/meta/heart_count
readonly
List of Map
user_service_actions
Date
/user/updated
List
attachments
List of Uuid
/hidden/updated_attachments
Boolean
isAttachment
String
userAction
default:ToDo values: ToDo, Done
String
image
List of String
tags
Boolean
flagged
List of Note
publicComments
List of Note
privateComments
metadata
readonly
List of String
genres
List of String
recordLabels
String
bio
List of String
members
Note
Properties
String
name
default:New Note
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
default:not-public
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
String
description
List
reminders
String
publicBlurb
Number
personalRating
List of Uuid
workbooks
List of Uuid
/block/commenters
Map
/block/commenters_workbook_count
Number
/meta/heart_count
readonly
List of Map
user_service_actions
Date
/user/updated
List
attachments
List of Uuid
/hidden/updated_attachments
Boolean
isAttachment
String
userAction
default:ToDo values: ToDo, Done
String
image
List of String
tags
Boolean
flagged
List of Note
publicComments
List of Note
privateComments
metadata
readonly
String
url
String
text
Notebook
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
theme
default:lightlinen
String
accent
default:blue
List of String
tags
List of String
canvasItems
String
linkedGroup
deprecated
navItems
Date
/workbook/last_alert_read
List of Uuid
/workbook/latest_blocks
readonly
Date
/workbook/last_block_added
readonly
String
/workbook/cover_type
default:most_recent
String
/workbook/user_selected_image
String
/workbook/category
List of String
/workbook/most_recent_images
readonly
Date
/workbook/most_recent_images_updated
readonly
String
contents
metadata
readonly
/collab/creator
readonly
/collab/me
readonly
List of CollabMember
/collab/members
readonly
String
/collab/status
readonly
NotebookContents
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
List of String
items
String
workbook
Phone
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
Boolean
primary
default:false
String
type
values: Home Phone, Mobile Phone, Work Phone, Other Phone
String
number
Photo
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
default:not-public
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
String
/media/file_name
String
/media/mime_type
String
url
String
description
String
key
readonly
metadata
readonly
List of Map
image_assets
List of Map
audio_assets
List of Map
video_assets
List
reminders
String
publicBlurb
Number
personalRating
List of Uuid
workbooks
List of Uuid
/block/commenters
Map
/block/commenters_workbook_count
Number
/meta/heart_count
readonly
List of Map
user_service_actions
Date
/user/updated
List
attachments
List of Uuid
/hidden/updated_attachments
Boolean
isAttachment
String
userAction
default: values: ToDo, Done
String
image
List of String
tags
Boolean
flagged
List of Note
publicComments
List of Note
privateComments
Product
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
default:not-public
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
String
description
List
reminders
String
publicBlurb
Number
personalRating
List of Uuid
workbooks
List of Uuid
/block/commenters
Map
/block/commenters_workbook_count
Number
/meta/heart_count
readonly
List of Map
user_service_actions
Date
/user/updated
List
attachments
List of Uuid
/hidden/updated_attachments
Boolean
isAttachment
String
userAction
default:ToDo values: ToDo, Done
String
image
List of String
tags
Boolean
flagged
List of Note
publicComments
List of Note
privateComments
metadata
readonly
String
price
String
category
String
manufacturer
String
model
String
upc
ProductivityCategory (deprecated)
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
String
color
values: #8F0000, #FFAA00, #FFF600, #4AAE00, #1D6413, #00CAD7, #0058BA, #1300A2, #7A00C7, #CC00D3
QuickAddItem (deprecated)
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
Recipe
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
default:not-public
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
String
description
List
reminders
String
publicBlurb
Number
personalRating
List of Uuid
workbooks
List of Uuid
/block/commenters
Map
/block/commenters_workbook_count
Number
/meta/heart_count
readonly
List of Map
user_service_actions
Date
/user/updated
List
attachments
List of Uuid
/hidden/updated_attachments
Boolean
isAttachment
String
userAction
default:ToDo values: ToDo, Done
String
image
List of String
tags
Boolean
flagged
List of Note
publicComments
List of Note
privateComments
metadata
readonly
String
servings
String
ingredientsText
String
preparationText
Boolean
sourceAdapted
String
cuisine
String
course
String
mainIngredient
Number
prepTime
default:-1.0
String
prepPeriod
Number
cookTime
default:-1.0
String
cookPeriod
Number
totalTime
default:-1.0
String
totalPeriod
Reminder
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
metadata
readonly
Number
timeBefore
default:30.0
String
periodBefore
default:minutes before
BaseDataType
owner
List of Channel
channels
Date
scheduled
readonly
List of String
forcePush
Restaurant
Sub-type of:
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
default:not-public
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
List
addresses
List
contactInfo
List
accounts
String
neighborhood
String
description
List
reminders
String
publicBlurb
Number
personalRating
List of Uuid
workbooks
List of Uuid
/block/commenters
Map
/block/commenters_workbook_count
Number
/meta/heart_count
readonly
List of Map
user_service_actions
Date
/user/updated
List
attachments
List of Uuid
/hidden/updated_attachments
Boolean
isAttachment
String
userAction
default:ToDo values: ToDo, Done
String
image
List of String
tags
Boolean
flagged
List of Note
publicComments
List of Note
privateComments
metadata
readonly
List of String
cuisines
String
price
String
menuUrl
menuFile
menuFavorites
Springpad User
Sub-type of:
Properties
String
firstName
String
lastName
String
username
SecurityToken
securityToken
readonly
List of Notebook
workbooks
List of BetaFeature
betas
readonly
List
integrationAccounts
String
facebook/id
readonly
String
facebook/token
Number
publicWorkbookCount
readonly
List of Map
help-accessed
Date
/system/last_alert_read
List of String
alertsViewed
Number
totalItemsSprung
readonly
List
channels
productivityCategories
deprecated
String
feedKeys
readonly
String
source
String
sourceCampaign
String
registrationOrigin
String
registrationMethod
Subscription
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
TV Show
Properties
String
name
default:New tv show...
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
default:not-public
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
List of String
cast
List of String
directors
List of String
writers
List of String
producers
String
rating
String
thumbUrl
String
plot
List of String
awards
String
description
List
reminders
String
publicBlurb
Number
personalRating
List of Uuid
workbooks
List of Uuid
/block/commenters
Map
/block/commenters_workbook_count
Number
/meta/heart_count
readonly
List of Map
user_service_actions
Date
/user/updated
List
attachments
List of Uuid
/hidden/updated_attachments
Boolean
isAttachment
String
userAction
default:ToDo values: ToDo, Done
String
image
List of String
tags
Boolean
flagged
List of Note
publicComments
List of Note
privateComments
metadata
readonly
String
season
Task
Properties
String
name
default:New Task
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
default:not-public
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
String
description
List
reminders
String
publicBlurb
Number
personalRating
List of Uuid
workbooks
List of Uuid
/block/commenters
Map
/block/commenters_workbook_count
Number
/meta/heart_count
readonly
List of Map
user_service_actions
Date
/user/updated
List
attachments
List of Uuid
/hidden/updated_attachments
Boolean
isAttachment
String
userAction
default:ToDo values: ToDo, Done
String
image
List of String
tags
Boolean
flagged
List of Note
publicComments
List of Note
privateComments
metadata
readonly
date
List
assignees
Boolean
complete
taskList
category
deprecated
Boolean
hasDueDate
Task List (deprecated)
Properties
String
name
default:Task List
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
default:not-public
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
List of Task
tasks
Theme
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
Track
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
String
duration
Tracking Number
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
String
number
String
status
User
Properties
String
firstName
String
lastName
String
username
SecurityToken
securityToken
readonly
Video
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
default:not-public
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
String
/media/file_name
String
/media/mime_type
String
url
String
description
String
key
readonly
metadata
readonly
List of Map
image_assets
List of Map
audio_assets
List of Map
video_assets
List
reminders
String
publicBlurb
Number
personalRating
List of Uuid
workbooks
List of Uuid
/block/commenters
Map
/block/commenters_workbook_count
Number
/meta/heart_count
readonly
List of Map
user_service_actions
Date
/user/updated
List
attachments
List of Uuid
/hidden/updated_attachments
Boolean
isAttachment
String
userAction
default: values: ToDo, Done
String
image
List of String
tags
Boolean
flagged
List of Note
publicComments
List of Note
privateComments
Wine
Properties
String
name
Map
/meta/attribution
readonly
String
/meta/originalSourceBlock
deprecated readonly
String
/meta/sourceBlock
deprecated readonly
String
/meta/originalSourceBlockUser
deprecated readonly
String
/meta/sourceBlockUser
deprecated readonly
String
/meta/sourceUrl
String
/meta/sourceAction
String
/meta/published
default:not-public
String
/meta/clientApp
String
/meta/sourceClient
String
/meta/sourceService
String
/meta/searchable
String
/meta/url
readonly
String
/meta/privateUrl
readonly
String
/meta/sourceTitle
readonly
Map
/meta/springs
readonly
List of String
services
List of Map
/meta/sources
String
sbr_id
Uuid
/collab/added_by
readonly
List of String
/collab/tags
List of String
/collab/flagged
List of String
/collab/rating
List of String
/collab/user_action
List of String
/user_hidden_assets
String
description
List
reminders
String
publicBlurb
Number
personalRating
List of Uuid
workbooks
List of Uuid
/block/commenters
Map
/block/commenters_workbook_count
Number
/meta/heart_count
readonly
List of Map
user_service_actions
Date
/user/updated
List
attachments
List of Uuid
/hidden/updated_attachments
Boolean
isAttachment
String
userAction
default:ToDo values: ToDo, Done
String
image
List of String
tags
Boolean
flagged
List of Note
publicComments
List of Note
privateComments
metadata
readonly
String
vineyard
String
varietal
String
vintage
String
label
Number
price
List
ratings
String
wineType
String
region